using PkmnLib.Static.Moves;

namespace PkmnLib.Plugin.Gen7.Scripts.Pokemon;

[Script(ScriptCategory.Pokemon, "taunt")]
public class TauntEffect(int turns) : Script, IScriptPreventMoveSelection, IScriptFailMove, IScriptOnEndTurn
{
    private int _turns = turns;

    /// <inheritdoc />
    public void PreventMoveSelection(IMoveChoice choice, ref bool prevent)
    {
        if (choice.ChosenMove.MoveData.Category == MoveCategory.Status)
        {
            prevent = true;
        }
    }

    /// <inheritdoc />
    public void FailMove(IExecutingMove move, ref bool fail)
    {
        if (move.ChosenMove.MoveData.Category == MoveCategory.Status)
        {
            fail = true;
        }
    }

    public void OnEndTurn(IScriptSource owner, IBattle battle)
    {
        _turns--;
        if (_turns <= 0)
            RemoveSelf();
    }
}